/*
 * kplib.h  Used by kptop to create a UI for the kernel profiler.
 *
 * Derived from GPLed sources for "kernprof", maintained at oss.sgi.com.
 */

#ifndef _KPLIB_H

#define _KPLIB_H 1

#include "gmon_out.h"

typedef struct {
	address_t addr;
	u_int count;
	char name[248];
} prof_t;

#define MAX_CPUS			1024
#define BITS_PER_LONG		(sizeof(u_long)*8)
#define BITMAP_WORDCOUNT	((MAX_CPUS + BITS_PER_LONG - 1)/BITS_PER_LONG)
typedef u_long cpu_map_t[BITMAP_WORDCOUNT];

int kp_init(char *mapfile, void (*errfunc)(int), char *progname);
void kp_exit(void);
void kp_stop(void);
void kp_reset(void);
void kp_set_sleep(u_int sleep);
int kp_set_event(u_int event);
int kp_set_pid(u_long pid);
int kp_set_mode(u_int mode);
int kp_set_domain(u_int domain);
int kp_set_freq(u_int freq);
void kp_set_cpu_map(cpu_map_t cpu_map);
void kp_get_cpu_map(cpu_map_t *cpu_map);
void kp_start(void);
prof_t **kp_get_prof(prof_t **table, int *entries, int *ticks);
void kp_write_file(char *filename);

#endif
